<?php
namespace Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\DevOps\Util\Utilities;
use \Service\Mnemonic as MnemonicService;

use Zeedhi\Framework\DTO\Request\Row as RequestRow;

use Zeedhi\Framework\DTO\Request\DataSet as RequestDataset;

class Mnemonic {
    private $mnemonicServer;

    public function __construct(MnemonicService $mnemonicService) {
        $this->mnemonicService = $mnemonicService;
    }

    public function find(Request\Filter $request, Response $response) {
        try {
            $conditions    = $request->getFilterCriteria()->getConditions();
            $page = $request->getFilterCriteria()->getPage();
            $pageSize = $request->getFilterCriteria()->getPageSize();
            $Mnemonics = $this->mnemonicService->findMnemonicGrouping($conditions, $page, $pageSize);
            $response->addDataSet(new DataSet('Mnemonics', $Mnemonics));
        } catch(\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function save(Request\DataSet $request, Response $response) {
        try{
            $row = $request->getDataSet()->getRows();
            $row = $row[0];
            $id = empty($row['ID']) ? null : $row['ID'] ;
            $name = empty($row['NAME'])? null :$row['NAME'];
            $Mnemonics = $this->mnemonicService->saveMnemonicGruping($id, $name);
            $response->addDataSet(new DataSet('Mnemonics', $Mnemonics));
        }catch (\Exception $e){
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function delete(RequestRow $request, Response $response) {
        try{
            $row = $request->getRow();
            $id  = $row["ID"];
            $this->mnemonicService->deleteMnemonicGroup($id);
        }catch (\Exception $e){
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}