<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 25/09/2015
 * Time: 13:40
 */
namespace Factory;

use Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource;
use Zeedhi\DevOps\Model\Servermanager\Entities\Server as ServerEntity;
use Zeedhi\DevOps\Model\Servermanager\Entities\ProductServer;

class Server {
    /**
     * @param ServerEntity $server
     * @param $name
     * @param $wsEmail
     * @param $description
     * @param null $backupLimit
     * @param string $onlyApproved
     * @param $resource
     * @return ServerEntity
     */
    public function setServerRecords(ServerEntity $server, $name, $wsEmail, $description, $backupLimit = null,
                                     $onlyApproved = 'Y', Resource $resource = null, $isWindows = null, $isActive = null, $isProduction= null, $useBetaFilter = 'Y') {
        $server->setName($name);
        $server->setWsemail($wsEmail);
        $server->setDescription($description);
        $server->setBackupLimit($backupLimit);
        $server->setOnlyApprovedScripts($onlyApproved);
        $server->setResource($resource);
        $server->setIsWindows($isWindows);
        $server->setIsActive($isActive);
        $server->setIsProduction($isProduction);
        $server->setUseBetaFilter($useBetaFilter);
        return $server;
    }

    /**
     * @param ProductServer $productServer
     * @param $productId
     * @param $serverId
     * @param $useType
     * @param $baseUrl
     * @param $basePath
     * @return ProductServer
     */
    public function setProductServerRecords(ProductServer $productServer, $productId, $serverId, $useType, $baseUrl, $basePath, $backupLimit = null, $isActive = 'Y') {
        $productServer->setProduct($productId);
        $productServer->setServer($serverId);
        $productServer->setUsetype($useType);
        $productServer->setBaseUrl($baseUrl);
        $productServer->setPath($basePath);
        $productServer->setBackupLimit($backupLimit);
        $productServer->setIsActive($isActive);

        return $productServer;
    }
} 